% convert a program to binary form. JPG:  2.4.93


binary(F,F1) :-
	see(F),
	tell(F1),
	read(C),
	binary_clauses(C,1),
	seen,
	told.


binary_clauses(X,_) :- 
	end_of_file(X),
	!.
binary_clauses((A :- B1,B2),N) :- 
	functor(B2,F,_),
	F \== ',',
	!,
	canonical((A :- B1,B2)),
	write((A :- B1,B2)),
	write('.'),nl,
	read(C1),
	binary_clauses(C1,N).
binary_clauses((A :- B),N) :- 
	functor(B,F,_),
	F \== ',',
	!,
	canonical((A :- B)),
	write((A :- B)),
	write('.'),nl,
	read(C1),
	binary_clauses(C1,N).
binary_clauses((A :- B),N) :- 	% make new defs
	removelast(B,Bj,Bs1),
	N1 is N+1,
	vars(Bs1,Vs),
	newpredname(N,P),
	NewB =.. [P|Vs],
	copyterm((NewB :- Bs1),Copyclause),
	canonical((A :- NewB,Bj)),
	write((A :- NewB,Bj)),
	write('.'),nl,
	!,
	binary_clauses(Copyclause,N1).
binary_clauses(C,N) :- 		% copy anything else
	canonical(C),
	write(C),
	write('.'),nl,
	read(C1),
	!,
	binary_clauses(C1,N).


newpredname(K,P) :-
        name(K,Kn),
        name(new,T),
        app(T,Kn,Tn),
        name(P,Tn).


