left_ans_clauses(X,_) :- 
	end_of_file(X),
	!.
left_ans_clauses((:- _),S) :- 
	!,
	read(C1),
	!,
	left_ans_clauses(C1,S).
left_ans_clauses((A :- B),S) :- 
	!,
	left_answerlits(B,Bs),
	flat_name('_left_ans'(A),AA),
        flat_name(left_query(A),QA),
        flat_names(Bs,FBs),
	canonical((AA :- QA,FBs)),
	displayqRClauses([(AA :- QA,FBs)]),
	functor(A,F,N),
        memb1(F/N,S),
	read(C1),
	!,
	left_ans_clauses(C1,S).
left_ans_clauses(A,S) :- 
        flat_name('_left_ans'(A),AA),
        flat_name(left_query(A),QA),
        canonical((AA :- QA)),
        displayqRClauses([(AA :- QA)]),
	functor(A,F,N),
        memb1(F/N,S),
	read(C1),
	!,
	left_ans_clauses(C1,S).

left_answerlits((B,Bs),(B,Bs1)) :-
	sp_builtin(B),
	!,
	left_answerlits(Bs,Bs1).
left_answerlits((B,Bs),('_left_ans'(B),Bs1)) :-
	!,
	left_answerlits(Bs,Bs1).
left_answerlits(B,B) :-
	sp_builtin(B).
left_answerlits(B,'_left_ans'(B)).

right_ans_clauses(X) :- 
	end_of_file(X),
	!.
right_ans_clauses((:- _)) :- 
	!,
	read(C1),
	!,
	right_ans_clauses(C1).
right_ans_clauses((A :- B)) :- 
	!,
	right_answerlits(B,Bs),
        flat_name('_right_ans'(A),AA),
        flat_name(right_query(A),QA),
        flat_names(Bs,FBs),
        canonical((AA :- QA,FBs)),
        displayqRClauses([(AA :- QA,FBs)]),
	read(C1),
	!,
	right_ans_clauses(C1).
right_ans_clauses(A) :- 
        flat_name('_right_ans'(A),AA),
        flat_name(right_query(A),QA),
        canonical((AA :- QA)),
        displayqRClauses([(AA :- QA)]),
	read(C1),
	!,
	right_ans_clauses(C1).

right_answerlits((B,Bs),(B,Bs1)) :-
	sp_builtin(B),
	!,
	right_answerlits(Bs,Bs1).
right_answerlits((B,Bs),('_right_ans'(B),Bs1)) :-
	!,
	right_answerlits(Bs,Bs1).
right_answerlits(B,B) :-
	sp_builtin(B).
right_answerlits(B,'_right_ans'(B)).

magic(F,F1,Q) :-
	tell(F1),
	query_answer_clauses(F,Q),
	told.

query_answer_clauses(F,Q) :-
	see(F),
	read(C),
	left_ans_clauses(C,S),
	seen,
	see(F),
	read(C1),
	right_ans_clauses(C1),
	seen,
	see(F),
	read(C2),
	left_query_clauses(C2),
	seen,
	see(F),
	read(C3),
	right_query_clauses(C3),
	seen,
	write_ans_clauses(S),
	canonical(Q),
	flat_name(left_query(Q),LQ),
	flat_name(right_query(Q),RQ),
	displayqRClauses([(LQ :- true)]),
	nl,
	displayqRClauses([(RQ :- true)]),
	nl.

write_ans_clauses([]) :-
	!.
write_ans_clauses([P/N|S]) :-
	functor(A,P,N),
	canonical(A),
	flat_name(ans(A),AA),
	flat_name('_left_ans'(A),LA),
	flat_name('_right_ans'(A),RA),
	displayqRClauses([(AA :- LA,RA)]),
	!,
	write_ans_clauses(S).

left_query_clauses(X) :- 
	end_of_file(X),
	!.
left_query_clauses((A :- B)) :- 
	!,
	bodylit_left_queries(A,B),
	read(C1),
	!,
	left_query_clauses(C1).
left_query_clauses(_) :- 
	read(C1),
	!,
	left_query_clauses(C1).

bodylit_left_queries(_,true) :-
	!.
bodylit_left_queries(A,B) :-
	removelast(B,Bj,Bs1),
	sp_builtin(Bj),
	!,
	bodylit_left_queries(A,Bs1).
bodylit_left_queries(A,B) :-
	removelast(B,Bj,Bs1),
	!,
	left_answerlits(Bs1,Bs2),
	flat_name(left_query(Bj),LQ),
	flat_names((left_query(A),Bs2),FB),
	canonical((LQ :- FB)),
	displayqRClauses([(LQ :- FB)]),
	bodylit_left_queries(A,Bs1).

removelast((B,C,Bs),Bn,(B,Bs1)) :-
	!,
	removelast((C,Bs),Bn,Bs1).
removelast((B,C),C,B) :-
	!.
removelast(B,B,true).
	

right_query_clauses(X) :- 
	end_of_file(X),
	!.
right_query_clauses((A :- B)) :- 
	!,
	bodylit_right_queries(A,B),
	read(C1),
	!,
	right_query_clauses(C1).
right_query_clauses(_) :- 
	read(C1),
	!,
	right_query_clauses(C1).

bodylit_right_queries(_,true) :-
	!.
bodylit_right_queries(A,B) :-
	removefirst(B,Bj,Bs1),
	sp_builtin(Bj),
	!,
	bodylit_right_queries(A,Bs1).
bodylit_right_queries(A,B) :-
	removefirst(B,Bj,Bs1),
	!,
	right_answerlits(Bs1,Bs2),
	flat_name(right_query(Bj),RQ),
        flat_names((right_query(A),Bs2),FB),
        canonical((RQ :- FB)),
        displayqRClauses([(RQ :- FB)]),
	bodylit_right_queries(A,Bs1).

removefirst((B,Bs),B,Bs) :-
	!.
removefirst(B,B,true).
	
flat_name(A,A) :-
        sp_builtin(A),
        !.
flat_name(A,A1) :-
        A =.. [F,As],
        As =.. [G|Args],
        name(F,Fn),
        name(G,Gn),
        concat(Gn,[95|Fn],An),
        name(H,An),
        A1 =.. [H|Args].

flat_names((B,Bs),(B1,Bs1)) :-
        !,
        flat_name(B,B1),
        flat_names(Bs,Bs1).
flat_names(B,B1) :-
        flat_name(B,B1).

concat([],Xs,Xs).
concat([X|Xs],Ys,[X|Zs]) :-
        concat(Xs,Ys,Zs).


