/* JPG: 1.9.91 */
/* determinate unfolding with user-controlled unfolding choices */

resultant(A,R) :-
	resultant(A,_,[],R).

resultant(A,Path,R) :-
	resultant(A,Path,[],R).

resultant(G,[N|P10],P3,R2) :-
	ref_clause(G,B,N),
	prefix(B,P,P2,R,_),
	unfold_choices(R,P2,P3,R2,_),
	no_Deadend(R2),
	truncate(P,10,P10).
	
truncate([],_,[]).
truncate([X|_],1,[X]).
truncate([X|Xs],N,[X|Ys]) :-
	N > 1,
	N1 is N-1,
	truncate(Xs,N1,Ys).

/* Determinate unfolding only */

prefix(true,Ns,Ns,true,_) :-
	!.
prefix(Gs,Ns,Ns1,Gs1,det) :-
	select_lit(Gs,B,Gs3,N),
	choices(B,Ch,Gs3),
	Ch=[(C,(H :- R))],
	!,
	replace_goal(Gs,N,Gs2,H,R),
	prefix(Gs2,Ns,[(N,C)|Ns1],Gs1,det).
prefix(Gs,Ns,Ns,Gs,_) :-
	no_Deadend(Gs).

select_lit((G,Gs),G,Gs,1).
select_lit((B,Gs),G,(B,Gs1),N1) :-
	!,
	select_lit(Gs,G,Gs1,N),
	N1 is N+1.
select_lit(G,G,true,1).

unfold_choices(true,Ns,Ns,true,_) :-
	!.
unfold_choices(Gs,Ns,Ns1,Gs1,det) :-
	safe_select(Gs,B,N),
	unf(B),
	\+ imported(B),
	!,
	ref_clause(B,R,C),
	replace_goal(Gs,N,Gs2,B,R),
	no_Deadend(Gs2),
	unfold_choices(Gs2,Ns,[(N,C)|Ns1],Gs1,det).
unfold_choices(Gs,Ns,Ns1,Gs1,det) :-
	safe_select(Gs,B,N),
	evaluable(B),
	!,
	sp_solve(B),
	pattern(B,C),
	replace_goal(Gs,N,Gs2,B,true),
	no_Deadend(Gs2),
	unfold_choices(Gs2,Ns,[(N,C)|Ns1],Gs1,det).
unfold_choices(Gs,Ns,Ns,Gs,_) :-
	no_Deadend(Gs).

safe_select((G,_),G,1).
safe_select((B,Gs),G,N1) :-
	sp_builtin(B),
	!,
	safe_select(Gs,G,N),
	N1 is N+1.
safe_select(G,G,1).

replace_goal((G,true),2,G,_,_) :- /* eliminate true at end of goal */
	!.
replace_goal((G,Gs),1,Gs1,G,R) :-
	!,
	joingoals(R,Gs,Gs1).
replace_goal((G,Gs),N,(G,Gs1),H,R) :-
	!,
	N1 is N-1,
	replace_goal(Gs,N1,Gs1,H,R).
replace_goal(G,1,R,G,R).

/*

choices(clause(G,B),Cs,Gs) :-
	!,
	bagof((N,(clause(G,B) :- true)),[Gs]^(ref_clause(G,B,N),
		no_Deadend(Gs)),Cs).
choices(G,Ps,Gs) :-
	sp_builtin(G),
	unfoldable(G),
	!,
	pattern(G,P),
	bagof((P,(G :- true)),[Gs]^(call(G)), Ps).
choices(G,[],_) :-
	sp_builtin(G),
	!.
choices(G,[],_) :-
	imported(G),
	!.
choices(G,Ps,Gs) :-
	evaluable(G),
	!,
	pattern(G,P),
	bagof((P,(G :- true)),[Gs]^(sp_solve(G)), Ps).
choices(G,Cs,Gs) :-
	bagof((N,(G :- B)),
		[Gs]^(ref_clause(G,B,N)), Cs).

*/
choices(clause(G,B),Cs,Gs) :-
	!,
	bagof((N,(clause(G,B) :- true)),
		[Gs]^(ref_clause(G,B,N),no_Deadend(B),
		no_Deadend(Gs)),Cs).
choices(G,Ps,Gs) :-
	sp_builtin(G),
	unfoldable(G),
	!,
	pattern(G,P),
	bagof((P,(G :- true)),[Gs]^(call(G),no_Deadend(Gs)), Ps).
choices(G,[],_) :-
	sp_builtin(G),
	!.
choices(G,[],_) :-
	imported(G),
	!.
choices(G,Ps,Gs) :-
	evaluable(G),
	!,
	pattern(G,P),
	bagof((P,(G :- true)),[Gs]^(sp_solve(G),no_Deadend(Gs)), Ps).
choices(G,Cs,Gs) :-
	bagof((N,(G :- B)),
		[Gs]^(ref_clause(G,B,N),
		no_Deadend(B),no_Deadend(Gs)), Cs).
