% pure homeomorphic embedding

embedded(X,Y) :-
	var(X),
	var(Y).
embedded(S,T) :-
	nonvar(S),
	nonvar(T),
	functor(S,F,N),
	functor(T,F,N),
	pairwise_embedded(N,S,T),
	!.
embedded(S,T) :-
	nonvar(T),
	functor(T,_,N),
	some_embedded(N,S,T).

some_embedded(N,S,T) :-
	N > 0,
	arg(N,T,X),
	embedded(S,X).
some_embedded(N,S,T) :-
	N > 1,
	N1 is N-1,
	some_embedded(N1,S,T).

pairwise_embedded(0,_,_).
pairwise_embedded(N,S,T) :-
	N > 0,
	N1 is N-1,
	arg(N,S,X),
	arg(N,T,Y),
	embedded(X,Y),
	pairwise_embedded(N1,S,T).

