ans_clauses(X) :- 
	end_of_file(X),
	!.
ans_clauses((A :- B)) :- 
	!,
	answerlits(B,Bs),
	canonical((ans(A) :- query(A),Bs)),
	displayqRClauses([(ans(A) :- query(A),Bs)]),
	read(C1),
	!,
	ans_clauses(C1).
ans_clauses(A) :- 
        canonical((ans(A) :- query(A))),
        displayqRClauses([(ans(A) :- query(A))]),
	read(C1),
	!,
	ans_clauses(C1).

answerlits((B,Bs),(B,Bs1)) :-
	sp_builtin(B),
	!,
	answerlits(Bs,Bs1).
answerlits((B,Bs),(ans(B),Bs1)) :-
	!,
	answerlits(Bs,Bs1).
answerlits(B,B) :-
	sp_builtin(B),
	!.
answerlits(B,ans(B)).

answerlits((B,Bs),(B,Bs1),I,J) :-
	sp_builtin(B),
	!,
	J1 is J+1,
	answerlits(Bs,Bs1,I,J1).
answerlits((B,Bs),(FB,Bs1),I,J) :-
	!,
	flat_answer_name(B,I,J,FB),
	J1 is J+1,
	answerlits(Bs,Bs1,I,J1).
answerlits(B,B,_,_) :-
	sp_builtin(B),
	!.
answerlits(B,FB,I,J) :-
	flat_answer_name(B,I,J,FB).

flat_query_name(A,I,J,A1) :-
	name(query,Qn),
	name(I,In),
	name(J,Jn),
	concat([95|In],[95|Jn],Index),
	concat(Qn,Index,An),
	name(H,An),
	A1 =.. [H,A].

flat_answer_name(A,I,J,A1) :-
	name(ans,Ans),
	name(I,In),
	name(J,Jn),
	concat([95|In],[95|Jn],Index),
	concat(Ans,Index,An),
	name(H,An),
	A1 =.. [H,A].






magic(F,F1,Q) :-
	see(F),
	tell(F1),
	read(C),
	ans_clauses(C),
	seen,
	see(F),
	read(C1),
	query_clauses(C1,S,_,1),
	seen,
	flat_query_name(Q,0,1,QQ),
	functor(QQ,G,M),
	canonical( QQ ),
	displayqRClauses([(QQ :- true)]),
	nl,
	memb1(G/M,S),
	makelist(S),
%	list(S1),
	query_def(S),
%	concat(S,[ans/1,query/1|S1],S2),
%	displayqRClauses([(program_preds(S2) :- true)]),
	told.

%ans_def([P/1|Ps]) :-
%	B =.. [P,'X'],
%	displayqRClauses([(ans('X') :- B)]),
%	ans_def(Ps).
%ans_def([]).

query_def([P/1|Ps]) :-
	B =.. [P,'X0'],
	displayqRClauses([(query('X0') :- B)]),
	query_def(Ps).
query_def([]).

query_clauses(Z,_,_,_) :- 
	end_of_file(Z),
	!.
query_clauses((A :- B),S,S1,N) :- 
	!,
	canonical((A :- B)),
	bodylitqueries(A,B,S,S1,N),
	read(C1),
	!,
	N1 is N+1,
	query_clauses(C1,S,S1,N1).
query_clauses(_,S,S1,N) :- 
	read(C1),
	!,
	N1 is N+1,
	query_clauses(C1,S,S1,N1).

bodylitqueries(_,true,_,_,_) :-
	!.
bodylitqueries(A,B,S,S1,I) :-
	removelast(B,Bj,Bs1,_),
	sp_builtin(Bj),
	!,
	bodylitqueries(A,Bs1,S,S1,I).
bodylitqueries(A,B,S,S1,I) :-
	removelast(B,Bj,Bs1,J),
	!,
	answerlits(Bs1,Bs2,I,1),
	flat_query_name(Bj,I,J,QBj),
	flat_answer_name(Bj,I,J,ABj),
	displayqRClauses([(QBj :- query(A),Bs2)]),
	displayqRClauses([(ABj :- QBj,ans(Bj))]),
	functor(QBj,F,1),
	memb1(F/1,S),
	functor(ABj,G,1),
	memb1(G/1,S1),
	bodylitqueries(A,Bs1,S,S1,I).

removelast((B,C,Bs),Bn,(B,Bs1),N) :-
	!,
	removelast((C,Bs),Bn,Bs1,N1),
	N is N1+1 .
removelast((B,C),C,B,2) :-
	!.
removelast(B,B,true,1).
	
concat([],Xs,Xs).
concat([X|Xs],Ys,[X|Zs]) :-
	concat(Xs,Ys,Zs).

/*
memb1(X,[X|_]) :-
	!.
memb1(X,[_|S]) :-
	memb1(X,S).

list([]) :-
	!.
list([_|Xs]) :-
	list(Xs).

*/
