:- dynamic program_preds/1.
:- dynamic program_pred/2.
:- dynamic ub_clause/2.
:- dynamic directive/1.
:- op(900,fy,not).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% change the definition of home_dir/1 when installing %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
home_dir('/home/staff/john/solaris/LP/').

/* Sicstus versions of builtins */

sp_builtin(G) :-
        predicate_property(G,built_in).


/* IO utilities */

sp_writeClause((H :- B)) :-
	canonical((H :- B)),
        write(H),
        write(' :- '),nl,
        writeqBody(B).

sp_writeRclause((H :- B)) :-
	canonical((H :- B)),
        write(H),
        write(' :- '),
        writeqRBody(B).

new_line :-
        nl,
        tab(6).

getchar(C) :-
        ttyget(Ch),
        name(C,[Ch]).

sp_ttyflush :-
	ttyflush.

sp_ttynl :-
	ttynl.

sp_length(X,N) :-
	length(X,N).

end_of_file(end_of_file).

ref_clause(G,B,N) :-
	clause(ub_clause(G,B),true,N).

ref_clause(G,B) :-
	clause(ub_clause(G,B),true).

re_read(F) :-
	home_dir(D),
	concatstring(D,F,Fullpath),
	compile(Fullpath).
my_reconsult(F) :-
	home_dir(D),
	concatstring(D,F,Fullpath),
	compile(Fullpath).

directive(dummy).

concatstring(S1,S2,S3) :-
        name(S1,N1),
        name(S2,N2),
        app(N1,N2,N3),
        name(S3,N3).

app([],Ys,Ys).
app([X|Xs],Ys,[X|Zs]) :-
        app(Xs,Ys,Zs).

compileall([]).
compileall([F|Fs]) :-
	re_read(F),
	compileall(Fs).

sp_consult_tt(F) :-
        tt(F,temp_tt),
        sp_consult(temp_tt).

?- use_module(library(clpq)),
  use_module(library(system)),
	compileall([
	'APE/sp.pl',
	'APE/ape.pl',
	'APE/utils.pl',
	'APE/unfold_utils.pl',
	'APE/cleanup.pl',
	'APE/msv_detpath.pl','APE/sp_main.pl',
	'Types/tp_alpha.pl', 'Types/ub.pl',
	'Types/is.pl','Types/subtype.pl',
	%   '~john/LP/Types/tp_rul.pl', '~john/LP/Types/ub2.pl',
	%    '~john/LP/Types/is2.pl','~john/LP/Types/subtype2.pl',
	%    '~john/LP/Types/subtype_any.pl',
	'Types/dg3.pl',
	'APE/magic1.pl',
	'APE/reex_trans.pl',
	'APE/binary.pl',
	'APE/unf.pl',
	'Types/precision.pl',
	'Types/modelize.pl',
	'Types/rule2clause.pl',
	'APE/traceterms.pl',
	'APE/mgu.pl',
	'APE/convexhull.pl',
	'APE/time.pl',
	'APE/sp_consult.pl']).

/* consult files for debugging

?- ['~john/LP/APE/cape.pl',
    '~john/LP/APE/sp.pl',
	'~john/LP/APE/utils.pl','~john/LP/APE/unfold_utils.pl',
    '~john/LP/APE/cleanup.pl',
    '~john/LP/APE/msv_detpath.pl','~john/LP/APE/sp_main.pl',
    '~john/LP/Types/tp_alpha_any.pl', '~john/LP/Types/ub_any.pl',
    '~john/LP/Types/is_any.pl','~john/LP/Types/subtype_any.pl',
%    '~john/LP/Types/tp_rul.pl', '~john/LP/Types/ub2.pl',
%    '~john/LP/Types/is2.pl','~john/LP/Types/subtype2.pl',
%    '~john/LP/Types/subtype_any.pl',
    '~john/LP/Types/dg3.pl',
    '~john/LP/APE/magic1.pl',  
    '~john/LP/APE/reex_trans.pl',
    '~john/LP/APE/binary.pl',  
    '~john/LP/APE/unf.pl',
    '~john/LP/APE/time.pl',
    '~john/LP/Types/precision.pl',
    '~john/LP/Types/modelize.pl',
    '~john/LP/Types/rule2clause.pl',
    '~john/LP/Types/traceterms.pl',
%    '~john/LP/APE/sounds.pl',
    '~john/LP/APE/sp_consult.pl'].
*/
