traceterm_clauses(X,_) :- 
	end_of_file(X),
	!.
traceterm_clauses((A :- B),N) :- 
	!,
	tracetermlits(B,Bs,Args),
	A =.. [P|Ys],
	clauseid(C,N,Args),
	A1 =.. [P,C|Ys],
	canonical((A1 :- Bs)),
	displayqRClauses([(A1 :- Bs)]),
	read(C1),
	!,
	N1 is N+1,
	traceterm_clauses(C1,N1).
traceterm_clauses(A,N) :- 
	A =.. [P|Ys],
	clauseid(C,N,[]),
	A1 =.. [P,C|Ys],
	canonical(A1),
	displayqRClauses([(A1 :- true)]),
	read(C1),
	!,
	N1 is N+1,
	traceterm_clauses(C1,N1).

tracetermlits((\+ B,Bs),(\+ B,Bs1),[not(B)|Args]) :-
	!,
	tracetermlits(Bs,Bs1,Args).
tracetermlits((B,Bs),(B,Bs1),[B|Args]) :-
	sp_builtin(B),
	!,
	tracetermlits(Bs,Bs1,Args).
tracetermlits((B,Bs),(B1,Bs1),[X|Args]) :-
	!,
	B =.. [P|Ys],
	B1 =..[P,X|Ys],
	tracetermlits(Bs,Bs1,Args).
tracetermlits(true,true,[]) :-
	!.
tracetermlits(\+(B),\+(B),[not(B)]) :-
	!.
tracetermlits(B,B,[B]) :-
	sp_builtin(B),
	!.
tracetermlits(B,B1,[X]) :-
	B =.. [P|Ys],
        B1 =..[P,X|Ys].

clauseid(C,N,Xs) :-
	name(c,[Cn]),
	name(N,Nn),
	name(CN,[Cn|Nn]),
	C =.. [CN|Xs].

traceterm_transform(F,F1) :-
	see(F),
	tell(F1),
	read(C),
	traceterm_clauses(C,1),
	seen,
	nl,
	told.

tt(X,Y) :-
	traceterm_transform(X,Y).
