/* determinate unfolding with user-controlled unfolding choices */


resultant(catom(G,(U,C)),P,(R,U1,C),K0) :-
	var(P),				% trace term is not known
	!,
	ref_clause(G,B),
	derivation(B,R,U,C,K0),
	unfold_body(U,C,U1),
	non_empty_rul(U1,C,K0),
	no_Deadend(R),
	return_abstraction(G,P).	% return the trace term 
resultant(catom(G,(U,C)),pp(_,P),(R,U1,C),K0) :-
	nonvar(P),
	!,
	melt(P,TT),
	arg(1,G,TT),
	unfold_with_traceterm(G,R),
	unfold_body(U,C,U1),
	non_empty_rul(U1,C,K0),
	no_Deadend(R).
resultant(catom(G,(U,C)),P,(R,U1,C),K0) :-
	nonvar(P),
	melt(P,TT),
	arg(1,G,TT),
	unfold_with_traceterm(G,R),
	unfold_body(U,C,U1),
	non_empty_rul(U1,C,K0),
	no_Deadend(R).
	

rul_consistent(U,C,K) :-
	rul_consistent(U,C,_,K).

rul_consistent(U,C,U1,K) :-
	unfold_body(U,C,U1),
	non_empty_rul(U1,C,K).
	
%return_abstraction(statement(P,_,[p(N,_)|_],_),pp(N,P)) :-
%	!.
return_abstraction(G,P) :-
	arg(1,G,P).			% Trace term is 1st argument


non_empty_rul(U1,C,K0) :-
	intersect_body(U1,C,_,_,K0,_).

/* Determinate unfolding only */

derivation(true,true,_,_,_) :-
	!.
derivation(Gs,Gs1,U,C,K) :-
	derivation_step(Gs,Gs2,true,Suspend,U,C,K),
	no_Deadend(Gs2),
	rul_consistent(U,C,U1,K),
	derivation_continue(Suspend,Gs2,Gs1,U1,C,K).

derivation_continue(yes,Gs,Gs,_,_,_).
derivation_continue(no,Gs2,Gs1,U,C,K) :-
	derivation(Gs2,Gs1,U,C,K).
	
derivation_step((\+G,Gs),Gs,_,no,_,_,_) :-
	unfoldable(\+G),
	!,
	\+ sp_solve(G).
derivation_step((B,Gs),Gs,_,no,_,_,_) :-
	sp_builtin(B),
	unfoldable(B),
	!,
	call(B).
derivation_step((B,Gs),(B,Gs1),Hs,Susp,U,C,K) :-
	sp_builtin(B),
	!,
	derivation_step(Gs,Gs1,(B,Hs),Susp,U,C,K).
derivation_step((B,Gs),(B,Gs1),Hs,Susp,U,C,K) :-
	suspend_goal((B,Gs),U,C,K),
	!,
	derivation_step(Gs,Gs1,(B,Hs),Susp,U,C,K).
derivation_step((B,Gs),Gs1,_,no,_,_,_) :-
	!,
	ref_clause(B,R),
	joingoals(R,Gs,Gs1).
derivation_step(\+B,true,_,no,_,_,_) :-
	unfoldable(\+B),
	!,
	\+ sp_solve(B).
derivation_step(B,true,_,no,_,_,_) :-
	sp_builtin(B),
	B \== true,
	unfoldable(B),
	!,
	call(B).
derivation_step(B,B,_,yes,_,_,_) :-
	sp_builtin(B),
	!.
derivation_step(B,B,Hs,yes,U,C,K) :-
	suspend_goal((B,Hs),U,C,K),
	!.
derivation_step(B,R,_,no,_,_,_) :-
	ref_clause(B,R).

% user defined suspend conditions, if any, go here

suspend_goal(statement(_,_,S,_),_,_,_) :-
	nonvar(S),
	S = [p(_,_)|_],
	!.
suspend_goal((statement(_,_,S,_),_),_,_,_) :-
	nonvar(S),
	S = [p(_,_)|_],
	!.
suspend_goal(B,U,C,K) :-
	nondeterminate(B,U,C,K).

/*
nondeterminate((G,Gs),U,C,K) :-
	!,
	findall(Bs, (
		ref_clause(G,B),
		joingoals(B,Gs,Bs),
		no_Deadend(Bs),
		rul_consistent(U,C,K)),[_,_|_]).
nondeterminate(G,U,C,K) :-
	findall(B, (
		ref_clause(G,B),
		no_Deadend(B),
		rul_consistent(U,C,K)),[_,_|_]).
*/

nondeterminate((G,Gs),U,C,K) :-
	!,
	bagof(Bs, (G,Gs,B,U)^(
		ref_clause(G,B),
		joingoals(B,Gs,Bs),
		no_Deadend(Bs),
		rul_consistent(U,C,K)),[_,_|_]).
nondeterminate(G,U,C,K) :-
	bagof(B, (G,U)^(
		ref_clause(G,B),
		no_Deadend(B),
		rul_consistent(U,C,K)),[_,_|_]).

unfold_with_traceterm(true,true) :-
	!.
unfold_with_traceterm((G,Gs),R) :-
	!,
	unfold_with_traceterm(G,G1),
	unfold_with_traceterm(Gs,Gs1),
	joingoals(G1,Gs1,R).
unfold_with_traceterm(\+B,true) :-
        unfoldable(\+B),
	!,
        \+ sp_solve(B).
unfold_with_traceterm(\+B,\+B) :-
        !.
unfold_with_traceterm(B,true) :-
        sp_builtin(B),
        unfoldable(B),
	!,
        call(B).
unfold_with_traceterm(B,B) :-
        sp_builtin(B),
        !.
unfold_with_traceterm(B,B) :-
        arg(1,B,TT),
	var(TT),
        !.
unfold_with_traceterm(B,R) :-
        ref_clause(B,R1),
	unfold_with_traceterm(R1,R).

